// ChildView.cpp : CChildView NX̓̒`s܂B
//

#include "stdafx.h"
#include "Life.h"
#include "MainFrm.h"
#include "ChildView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChildView

CChildView::CChildView()
{
  m_bIsSet = m_bIsDrawing = FALSE;
  m_bPlaying = FALSE;
  m_pLife = NULL;
  m_pBits = NULL;

  m_hEvent = CreateEvent(NULL, FALSE, FALSE, _T("Event"));
  m_dwSpinLock = m_dwGeneration = 0UL;
  m_hThread = NULL;
}

CChildView::~CChildView()
{
  if(m_hThread) {
    TerminateThread(m_hThread, 0UL);
    m_hThread = NULL;
  }
  CloseHandle(m_hEvent);
  if(m_pLife) {
    delete m_pLife;
    m_pLife = NULL;
  }
  if(m_pBits) {
    delete[] m_pBits;
    m_pBits = NULL;
  }
}


BEGIN_MESSAGE_MAP(CChildView, CWnd)
  //{{AFX_MSG_MAP(CChildView)
  ON_WM_PAINT()
  ON_WM_LBUTTONDOWN()
  ON_WM_LBUTTONUP()
  ON_WM_RBUTTONDOWN()
  ON_WM_RBUTTONUP()
  ON_WM_SIZE()
  ON_UPDATE_COMMAND_UI(ID_PLAYBUTTON, OnUpdatePlaybutton)
  ON_COMMAND(ID_PLAYBUTTON, OnPlaybutton)
  ON_UPDATE_COMMAND_UI(ID_STEPBUTTON, OnUpdateStepbutton)
  ON_COMMAND(ID_STEPBUTTON, OnStepbutton)
  ON_UPDATE_COMMAND_UI(ID_STOPBUTTON, OnUpdateStopbutton)
  ON_COMMAND(ID_STOPBUTTON, OnStopbutton)
  ON_WM_TIMER()
  //}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CChildView::DoResize()
{
  RECT rct;
  GetClientRect(&rct);

  if((rct.right -= rct.left) == 0 ||
     (rct.bottom -= rct.top) == 0)
    return TRUE;

  m_pLife->Resize(rct.right, rct.bottom);
  if(m_pBits) delete[] m_pBits;
  m_pBits = new BYTE[(((rct.right + 7) >> 3) + 1 & ~1) * rct.bottom];
  m_pLife->MakeBits(m_pBits);
  m_Bitmap.DeleteObject();
  return m_Bitmap.CreateBitmap(rct.right, rct.bottom, 1, 1, m_pBits);
}

void CChildView::UpdateBitmap()
{
  const unsigned long uSize =
    (((m_pLife->GetWidth() + 7) >> 3) + 1 & ~1) * m_pLife->GetHeight();
  AcquireSpinLock();
  m_pLife->MakeBits(m_pBits);
  ReleaseSpinLock();
  m_Bitmap.SetBitmapBits(uSize, m_pBits);
  InvalidateRect(NULL, FALSE);

  if(m_bPlaying) {
    static TCHAR buffer[256];
    DWORD dwNow = GetTickCount();
    if(dwNow - m_dwPrevTick >= 1000) {
      m_dwGPS = (m_dwGeneration - m_dwPrevGen) * 1000 / (dwNow - m_dwPrevTick);
      m_dwPrevGen = m_dwGeneration;
      m_dwPrevTick = dwNow;
    }
    _stprintf(buffer, _T("Generation = %lu [%lu Generation/sec]"),
      m_dwGeneration, m_dwGPS);
    ((CMainFrame *) this->GetParentFrame())->m_wndStatusBar.SetWindowText(buffer);
  }
}

DWORD CChildView::GenerateThread(LPVOID lpvParam)
{
  CChildView *pThis = (CChildView *) lpvParam;
  while(::IsWindow(pThis->m_hWnd)) {
    WaitForSingleObject(pThis->m_hEvent, INFINITE);
    while(pThis->m_bPlaying) {
      //pThis->AcquireSpinLock();
      pThis->m_pLife->Next();
      //pThis->ReleaseSpinLock();
      pThis->m_dwGeneration++;
    }
    //SetEvent(pThis->m_hEvent);
  }
  return 0UL;
}

/////////////////////////////////////////////////////////////////////////////
// CChildView bZ[W nh

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
  if (!CWnd::PreCreateWindow(cs))
    return FALSE;

  cs.dwExStyle |= WS_EX_CLIENTEDGE;
  cs.style &= ~WS_BORDER;
  cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
    ::LoadCursor(NULL, IDC_ARROW), HBRUSH(COLOR_WINDOW+1), NULL);

  m_pLife = new CLifeGame();
  m_hThread = CreateThread(NULL, 0UL, GenerateThread, (LPVOID) this, 0UL, NULL);
  return TRUE;
}

void CChildView::OnPaint() 
{
  CPaintDC dc(this); // `p̃foCX ReLXg
	
  // TODO: bZ[W nh̃R[hɒǉĂB
  RECT rct;
  GetClientRect(&rct);

  CDC MemDC;
  MemDC.CreateCompatibleDC(&dc);
  CBitmap *pOldBitmap = MemDC.SelectObject(&m_Bitmap);
  dc.BitBlt(rct.left, rct.top, rct.right - rct.left, rct.bottom - rct.top,
    &MemDC, 0, 0, SRCCOPY);
  MemDC.SelectObject(pOldBitmap);
}

void CChildView::OnLButtonDown(UINT nFlags, CPoint point) 
{
  if(m_bPlaying) return;
  m_bIsDrawing = m_bIsSet = TRUE;
  m_pLife->SetCell(point.x, point.y, TRUE);
  UpdateBitmap();
}

void CChildView::OnLButtonUp(UINT nFlags, CPoint point) 
{
  if(m_bPlaying) return;
  m_bIsDrawing = FALSE;
}

void CChildView::OnRButtonDown(UINT nFlags, CPoint point) 
{
  if(m_bPlaying) return;
  m_bIsSet = FALSE;
  m_bIsDrawing = TRUE;
  m_pLife->SetCell(point.x, point.y, FALSE);
  UpdateBitmap();
}

void CChildView::OnRButtonUp(UINT nFlags, CPoint point) 
{
  if(m_bPlaying) return;
  m_bIsDrawing = FALSE;
}

void CChildView::OnSize(UINT nType, int cx, int cy) 
{
  CWnd ::OnSize(nType, cx, cy);

  // TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
  if(IsWindowEnabled() && !DoResize())
    ASSERT(FALSE);
}

/////////////////////////////////////////////////////////////////////////////
// UI Event Handler

void CChildView::OnUpdatePlaybutton(CCmdUI* pCmdUI) 
{
  pCmdUI->Enable(! m_bPlaying);
}

void CChildView::OnUpdateStepbutton(CCmdUI* pCmdUI) 
{
  pCmdUI->Enable(! m_bPlaying);
}

void CChildView::OnUpdateStopbutton(CCmdUI* pCmdUI) 
{
  pCmdUI->Enable(m_bPlaying);
}

void CChildView::OnStepbutton() 
{
  // TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
  m_pLife->Next();
  UpdateBitmap();
}

void CChildView::OnPlaybutton() 
{
  // TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
  if(SetTimer(1, 100, NULL)) {
    m_dwPrevGen = m_dwGeneration;
    m_dwPrevTick = GetTickCount();
    m_dwGPS = 0UL;
    m_bPlaying = TRUE;
    SetEvent(m_hEvent);
  } else
    AfxMessageBox(_T("Failed to set a timer"), MB_ICONERROR | MB_OK, 0);
}

void CChildView::OnStopbutton() 
{
  // TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
  m_bPlaying = FALSE;
  KillTimer(1);
  //WaitForSingleObject(m_hEvent, INFINITE);
  UpdateBitmap();
}

void CChildView::OnTimer(UINT nIDEvent) 
{
  if(m_bPlaying) UpdateBitmap();
}
