#ifndef _MANAGEDARRAY_H
#define _MANAGEDARRAY_H 1

#include "StdAfx.h"

template<class T>
class ManagedArray {
  typedef T* PointerType;

private:
  unsigned long m_uSize;
  T *m_pData;
  volatile unsigned long m_uRefCount;

public:
  ManagedArray<T>(unsigned long uSize) {
    m_pData = new T[m_uSize = uSize];
    m_uRefCount = 0UL;
    Use();
  }

  virtual ~ManagedArray<T>() {
    ASSERT(m_uRefCount == 0);
    if(m_pData) delete[] m_pData;
  }

public:
  inline
  T* GetArray() { return m_pData; }
  /*inline
  operator T*() const { return m_pData; }*/

  inline
  T& operator [] (long idx) {
    ASSERT(idx >= 0 && idx < m_uSize);
    return m_pData[idx];
  }
  inline
  T& operator [] (long idx) const {
    ASSERT(idx >= 0 && idx < m_uSize);
    return m_pData[idx];
  }

public:
  unsigned long Use() { return ++m_uRefCount; }
  unsigned long Unuse() {
    register unsigned long result = --m_uRefCount;
    if(! result) delete this;
    return result;
  }
};

#endif/*_MANAGEDARRAY_H*/
